<center><a href="ex109.c">Actual source code: ex109.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:26:39+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a>static char help[] = <font color="#666666">"Test <A href="../../../../docs/manualpages/Mat/MatMatMult.html#MatMatMult">MatMatMult</A>() for AIJ and Dense matrices.\n\n"</font>;

<a name="line3"> 3: </a> #include <A href="../../../../include/petscmat.h.html">petscmat.h</A>

<a name="line7">  7: </a><strong><font color="#4169E1"><a name="main"></a>int main(int argc,char **argv)</font></strong>
<a name="line8">  8: </a>{
<a name="line9">  9: </a>  <A href="../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>            A,B,C,D;
<a name="line10"> 10: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,j,k,M=10,N=5;
<a name="line11"> 11: </a>  <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    *array,*a;
<a name="line13"> 13: </a>  <A href="../../../../docs/manualpages/Sys/PetscRandom.html#PetscRandom">PetscRandom</A>    r;
<a name="line14"> 14: </a>  <A href="../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     equal;
<a name="line15"> 15: </a>  <A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      fill = 1.0;
<a name="line16"> 16: </a>  <A href="../../../../docs/manualpages/Sys/PetscMPIInt.html#PetscMPIInt">PetscMPIInt</A>    <A href="../../../../docs/manualpages/Sys/size.html#size">size</A>;
<a name="line17"> 17: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       rstart,rend,nza,col,am,an,bm,bn;

<a name="line19"> 19: </a>  <A href="../../../../docs/manualpages/Sys/PetscInitialize.html#PetscInitialize">PetscInitialize</A>(&amp;argc,&amp;argv,(char *)0,help);
<a name="line20"> 20: </a>  <A href="http://www.mcs.anl.gov/mpi/www/www3/MPI_Comm_size.html#MPI_Comm_size">MPI_Comm_size</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;<A href="../../../../docs/manualpages/Sys/size.html#size">size</A>);
<a name="line21"> 21: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-M"</font>,&amp;M,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line22"> 22: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-N"</font>,&amp;N,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);

<a name="line24"> 24: </a>  <A href="../../../../docs/manualpages/Sys/PetscRandomCreate.html#PetscRandomCreate">PetscRandomCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;r);
<a name="line25"> 25: </a>  <A href="../../../../docs/manualpages/Sys/PetscRandomSetFromOptions.html#PetscRandomSetFromOptions">PetscRandomSetFromOptions</A>(r);

<a name="line27"> 27: </a>  <font color="#B22222">/* create a aij matrix A */</font>
<a name="line28"> 28: </a>  <A href="../../../../docs/manualpages/Mat/MatCreate.html#MatCreate">MatCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;A);
<a name="line29"> 29: </a>  <A href="../../../../docs/manualpages/Mat/MatSetSizes.html#MatSetSizes">MatSetSizes</A>(A,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,N,M);
<a name="line30"> 30: </a>  <font color="#4169E1">if</font> (<A href="../../../../docs/manualpages/Sys/size.html#size">size</A> == 1){
<a name="line31"> 31: </a>    <A href="../../../../docs/manualpages/Mat/MatSetType.html#MatSetType">MatSetType</A>(A,<A href="../../../../docs/manualpages/Mat/MATSEQAIJ.html#MATSEQAIJ">MATSEQAIJ</A>);
<a name="line32"> 32: </a>  } <font color="#4169E1">else</font> {
<a name="line33"> 33: </a>    <A href="../../../../docs/manualpages/Mat/MatSetType.html#MatSetType">MatSetType</A>(A,<A href="../../../../docs/manualpages/Mat/MATMPIAIJ.html#MATMPIAIJ">MATMPIAIJ</A>);
<a name="line34"> 34: </a>  }
<a name="line35"> 35: </a>  nza  = (<A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>)(.3*M); <font color="#B22222">/* num of nozeros in each row of A */</font>
<a name="line36"> 36: </a>  <A href="../../../../docs/manualpages/Mat/MatSeqAIJSetPreallocation.html#MatSeqAIJSetPreallocation">MatSeqAIJSetPreallocation</A>(A,nza,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line37"> 37: </a>  <A href="../../../../docs/manualpages/Mat/MatMPIAIJSetPreallocation.html#MatMPIAIJSetPreallocation">MatMPIAIJSetPreallocation</A>(A,nza,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,nza,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line38"> 38: </a>  <A href="../../../../docs/manualpages/Mat/MatGetOwnershipRange.html#MatGetOwnershipRange">MatGetOwnershipRange</A>(A,&amp;rstart,&amp;rend);
<a name="line39"> 39: </a>  <A href="../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>((nza+1)*<font color="#4169E1">sizeof</font>(<A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>),&amp;a);
<a name="line40"> 40: </a>  <font color="#4169E1">for</font> (i=rstart; i&lt;rend; i++) {
<a name="line41"> 41: </a>    <font color="#4169E1">for</font> (j=0; j&lt;nza; j++) {
<a name="line42"> 42: </a>      <A href="../../../../docs/manualpages/Sys/PetscRandomGetValue.html#PetscRandomGetValue">PetscRandomGetValue</A>(r,&amp;a[j]);
<a name="line43"> 43: </a>      col   = (<A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>)(M*PetscRealPart(a[j]));
<a name="line44"> 44: </a>      <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(A,1,&amp;i,1,&amp;col,&amp;a[j],<A href="../../../../docs/manualpages/Sys/ADD_VALUES.html#ADD_VALUES">ADD_VALUES</A>);
<a name="line45"> 45: </a>    }
<a name="line46"> 46: </a>  }
<a name="line47"> 47: </a>  <A href="../../../../docs/manualpages/Mat/MatAssemblyBegin.html#MatAssemblyBegin">MatAssemblyBegin</A>(A,MAT_FINAL_ASSEMBLY);
<a name="line48"> 48: </a>  <A href="../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>(A,MAT_FINAL_ASSEMBLY);

<a name="line50"> 50: </a>  <font color="#B22222">/* create a dense matrix B */</font>
<a name="line51"> 51: </a>  <A href="../../../../docs/manualpages/Mat/MatGetLocalSize.html#MatGetLocalSize">MatGetLocalSize</A>(A,&amp;am,&amp;an);
<a name="line52"> 52: </a>  <A href="../../../../docs/manualpages/Mat/MatCreate.html#MatCreate">MatCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;B);
<a name="line53"> 53: </a>  <A href="../../../../docs/manualpages/Mat/MatSetSizes.html#MatSetSizes">MatSetSizes</A>(B,an,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,N);
<a name="line54"> 54: </a>  <font color="#4169E1">if</font> (<A href="../../../../docs/manualpages/Sys/size.html#size">size</A> == 1){
<a name="line55"> 55: </a>    <A href="../../../../docs/manualpages/Mat/MatSetType.html#MatSetType">MatSetType</A>(B,<A href="../../../../docs/manualpages/Mat/MATSEQDENSE.html#MATSEQDENSE">MATSEQDENSE</A>);
<a name="line56"> 56: </a>  } <font color="#4169E1">else</font> {
<a name="line57"> 57: </a>    <A href="../../../../docs/manualpages/Mat/MatSetType.html#MatSetType">MatSetType</A>(B,<A href="../../../../docs/manualpages/Mat/MATMPIDENSE.html#MATMPIDENSE">MATMPIDENSE</A>);
<a name="line58"> 58: </a>  }
<a name="line59"> 59: </a>  <A href="../../../../docs/manualpages/Mat/MatSeqDenseSetPreallocation.html#MatSeqDenseSetPreallocation">MatSeqDenseSetPreallocation</A>(B,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line60"> 60: </a>  <A href="../../../../docs/manualpages/Mat/MatMPIDenseSetPreallocation.html#MatMPIDenseSetPreallocation">MatMPIDenseSetPreallocation</A>(B,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line61"> 61: </a>  <A href="../../../../docs/manualpages/Mat/MatGetLocalSize.html#MatGetLocalSize">MatGetLocalSize</A>(B,&amp;bm,&amp;bn);
<a name="line62"> 62: </a>  <A href="../../../../docs/manualpages/Mat/MatGetArray.html#MatGetArray">MatGetArray</A>(B,&amp;array);
<a name="line63"> 63: </a>  k = 0;
<a name="line64"> 64: </a>  <font color="#4169E1">for</font> (j=0; j&lt;N; j++){ <font color="#B22222">/* local column-wise entries */</font>
<a name="line65"> 65: </a>    <font color="#4169E1">for</font> (i=0; i&lt;bm; i++){
<a name="line66"> 66: </a>      <A href="../../../../docs/manualpages/Sys/PetscRandomGetValue.html#PetscRandomGetValue">PetscRandomGetValue</A>(r,&amp;array[k++]);
<a name="line67"> 67: </a>    }
<a name="line68"> 68: </a>  }
<a name="line69"> 69: </a>  <A href="../../../../docs/manualpages/Mat/MatRestoreArray.html#MatRestoreArray">MatRestoreArray</A>(B,&amp;array);
<a name="line70"> 70: </a>  <A href="../../../../docs/manualpages/Sys/PetscRandomDestroy.html#PetscRandomDestroy">PetscRandomDestroy</A>(r);
<a name="line71"> 71: </a>  <A href="../../../../docs/manualpages/Mat/MatAssemblyBegin.html#MatAssemblyBegin">MatAssemblyBegin</A>(B,MAT_FINAL_ASSEMBLY);
<a name="line72"> 72: </a>  <A href="../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>(B,MAT_FINAL_ASSEMBLY);

<a name="line74"> 74: </a>  <font color="#B22222">/* Used for testing with Matlab as checker </font>
<a name="line75"> 75: </a><font color="#B22222">  <A href="../../../../docs/manualpages/Viewer/PetscViewerSetFormat.html#PetscViewerSetFormat">PetscViewerSetFormat</A>(<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_WORLD.html#PETSC_VIEWER_STDOUT_WORLD">PETSC_VIEWER_STDOUT_WORLD</A>,PETSC_VIEWER_ASCII_MATLAB);</font>
<a name="line76"> 76: </a><font color="#B22222">  <A href="../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>(A,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_WORLD.html#PETSC_VIEWER_STDOUT_WORLD">PETSC_VIEWER_STDOUT_WORLD</A>);  </font>
<a name="line77"> 77: </a><font color="#B22222">  <A href="../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>(B,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_WORLD.html#PETSC_VIEWER_STDOUT_WORLD">PETSC_VIEWER_STDOUT_WORLD</A>);  */</font>

<a name="line79"> 79: </a>  <font color="#B22222">/* Test <A href="../../../../docs/manualpages/Mat/MatMatMult.html#MatMatMult">MatMatMult</A>() */</font>
<a name="line80"> 80: </a>  <A href="../../../../docs/manualpages/Mat/MatMatMult.html#MatMatMult">MatMatMult</A>(A,B,MAT_INITIAL_MATRIX,fill,&amp;C);

<a name="line82"> 82: </a>  <font color="#B22222">/* Used for testing with Matlab as checker </font>
<a name="line83"> 83: </a><font color="#B22222">  <A href="../../../../docs/manualpages/Mat/MatView.html#MatView">MatView</A>(C,<A href="../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_WORLD.html#PETSC_VIEWER_STDOUT_WORLD">PETSC_VIEWER_STDOUT_WORLD</A>);  </font>
<a name="line84"> 84: </a><font color="#B22222">  <A href="../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,"max(max(abs(Mat_3 - Mat_1*Mat_2)))\n");*/</font>

<a name="line86"> 86: </a>  <A href="../../../../docs/manualpages/Mat/MatMatMultSymbolic.html#MatMatMultSymbolic">MatMatMultSymbolic</A>(A,B,1.0,&amp;D);
<a name="line87"> 87: </a>  <font color="#4169E1">for</font> (i=0; i&lt;2; i++){
<a name="line88"> 88: </a>    <A href="../../../../docs/manualpages/Mat/MatMatMultNumeric.html#MatMatMultNumeric">MatMatMultNumeric</A>(A,B,D);
<a name="line89"> 89: </a>  }
<a name="line90"> 90: </a>  <A href="../../../../docs/manualpages/Mat/MatEqual.html#MatEqual">MatEqual</A>(C,D,&amp;equal);
<a name="line91"> 91: </a>  <font color="#4169E1">if</font> (!equal) <A href="../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(PETSC_ERR_ARG_WRONGSTATE,<font color="#666666">"C != D"</font>);

<a name="line93"> 93: </a>  <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(D);
<a name="line94"> 94: </a>  <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(C);
<a name="line95"> 95: </a>  <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(B);
<a name="line96"> 96: </a>  <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(A);
<a name="line97"> 97: </a>  <A href="../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(a);
<a name="line98"> 98: </a>  <A href="../../../../docs/manualpages/Sys/PetscFinalize.html#PetscFinalize">PetscFinalize</A>();
<a name="line99"> 99: </a>  <font color="#4169E1">return</font>(0);
<a name="line100">100: </a>}
</pre>
</body>

</html>
